/*
#
#    This distribution makes makes asynchronous client/server communication possible 
#    using TLVs (Type Length Value). It achieves that letting the user define
#    an IDL which serves as input to a code generator.  The code generated is linked in
#    the client and the server program.
#
#    Copyright (C) <2005>  <Sanjay Jaiman>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
*/

#include "myConn.h"

myConn *myConn::staticConn = NULL;

char *sanjayStr = "SanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjaySanjay";
unsigned int  sanjayStrLen = strlen(sanjayStr);

void sendTestTlv()
{
  myConn *conn = myConn::staticConn;
  if (!conn) {
    cout << "sendTestTlv:: No connection" << endl;
    return;
  }
  static int num = 0;
  printf("USER:: %s - This is test TLV #%d\n", 
	 (conn->isClient() ? "CLIENT" : "SERVER"), num++);
  struct_1 p1;
  p1.S1_1 = 5;
  p1.S1_2.putString(sanjayStr);
  if (p1.S1_2.Length != sanjayStrLen + 1) {
    cout << "sendTestTlv::ERROR::Making String param p1.S1_2" << endl;
  }
  p1.S1_3 = 1.5;
  p1.S1_4 = 6;

  struct_2 p2;
  p2.S2_1 = 15;
  p2.S2_2.putString(sanjayStr);
  if (p1.S1_2.Length != sanjayStrLen + 1) {
    cout << "sendTestTlv::ERROR::Making String param p2.S1_2" << endl;
  }
  p2.S2_3 = 10.5;
  p2.S2_4 = 16;
  p2.S2_5 = 17;
  p2.S2_6 = 18;
  
  if (conn->abcTX(&p1, &p2)){
    printf("--- abcTX SUCCESSFUL ---\n");
    //    printf("  sent - \n");
    //    p1.print("    "); p2.print("    ");
  } 
  else
    printf("--- abcTX FAILURE ---\n");
}

myConn::myConn(Connections *c, int clientOrServer) : myFirstConnBase(c, clientOrServer) 
{
  cout << "USER:: NEW CONNECTION" << endl;
}

myConn::myConn(Connections *c, int clientOrServer, int fd) : myFirstConnBase(c, clientOrServer, fd) 
{
  cout << "USER:: NEW CONNECTION" << endl;
}

void myConn::userConnectionEstablished()
{
  cout << "USER:: Connectin Established" << endl;
  //  sendTestTlv();
}

void myConn::userOkToSend()
{
  cout << "USER:: userOkToSend" << endl;
}


void myConn::userDisconnectProcessing()
{
  cout << "USER:: Connection disconnected" << endl;
  if (isServer()) {
    myConn::staticConn = NULL;  // Render connection unused
  }
}

void myConn::timer_routine(char *timerName)
{
  printf ("--- User timer myConn::timer_routine() called for timer - %s ---\n", timerName);
}



///////////////// CALLBACK FUNCTIONS /////////////////////

int  myConn::abcRX(struct_1 *p1, struct_2 *p2, struct_2 &p3)
{
  printf("myConn::abcRX::\n");
  p1->print("\t");
  p2->print("\t");

  p3.S2_1 = 55;
  p3.S2_2.putString(sanjayStr);
  p3.S2_3 = 65.5;
  p3.S2_4 = 75;
  p3.S2_5 = 85;
  p3.S2_6 = 95;
  
  sendTestTlv();
  return 1;
}
int  myConn::defRX(struct_3 *p1, struct_4 *p2)
{
  return 1;
}

void myConn::abcCB(struct_2 *p1)
{
  printf("myConn::abcCB::\n");
  p1->print("\t");
}
void myConn::defCB(struct_4 *p2)
{
}

