#ifndef _GLOBALS_H_
#define _GLOBALS_H_

/*
#
#    This distribution makes makes asynchronous client/server communication possible 
#    using TLVs (Type Length Value). It achieves that letting the user define
#    an IDL which serves as input to a code generator.  The code generated is linked in
#    the client and the server program.
#
#    Copyright (C) <2005>  <Sanjay Jaiman>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
*/

#include <stdlib.h>
#include <semaphore.h>

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif

struct mutex_struct
{
  sem_t   mutex;
  int     mutexInit;
};


extern int            trace_level;
extern unsigned long  subSystem_trace_mask;

#define REALLOC_COPY(dst, src) (  {(dst) = (char *)realloc((dst), strlen((src))+1); \
                                    bzero((dst), strlen((src))+1); \
                                    memcpy((dst), (src), strlen((src)));}  )

#define REALLOC_COPY_LEN(dst, src, len) (  {(dst) = (char *)realloc((dst), \
                                 ((strlen((src)) > len) ? len : strlen((src)))); \
                                 memcpy((dst), (src), ((strlen((src)) > len) ? len : strlen((src))));}  )

#define PRINTTRACE(l, m, s) \
            if (trace_level > (l) && (subSystem_trace_mask & (m))) \
                        printDebug((s), strlen((s))); 


#define STATICMUTEX(m) static struct mutex_struct (m) = {{{0,0}, 0, NULL}, 0};

#define GRABMUTEX(m) (  { if (!(m).mutexInit) \
                            if (sem_init(&(m).mutex, 0, 1) == 0) ((m).mutexInit) = 1; \
                          sem_wait(&(m).mutex);  }  )
  
#define RELEASEMUTEX(m) ( {sem_post(&(m).mutex);} )

// Susbsystems for tracing
#define SOCKET_LIB_TRACE      0x00000001

#ifdef __cplusplus
extern "C" {
#endif
  void printDebug(char *s, int buflen);
  void printTracingInfo(void);
#ifdef __cplusplus
}
#endif


#endif
